Package org.apache.sysds.runtime.instructions.spark

## Class ComputationSPInstruction

- java.lang.Object
- - org.apache.sysds.runtime.instructions.Instruction
  - - org.apache.sysds.runtime.instructions.spark.SPInstruction
    - - org.apache.sysds.runtime.instructions.spark.ComputationSPInstruction

All Implemented Interfaces:
  `LineageTraceable`

Direct Known Subclasses:
  `AggregateTernarySPInstruction`, `BinarySPInstruction`, `CtableSPInstruction`, `MultiReturnParameterizedBuiltinSPInstruction`, `ParameterizedBuiltinSPInstruction`, `QuaternarySPInstruction`, `TernarySPInstruction`, `UnarySPInstruction`

    public abstract class ComputationSPInstruction
    extends SPInstruction
    implements LineageTraceable

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.sysds.runtime.instructions.spark.SPInstruction

`SPInstruction.SPType`

### Nested classes/interfaces inherited from class org.apache.sysds.runtime.instructions.Instruction

`Instruction.IType`

### Field Summary

Fields
`CPOperand` `input1`
`CPOperand` `input2`
`CPOperand` `input3`
`CPOperand` `output`

### Fields inherited from class org.apache.sysds.runtime.instructions.Instruction

`DATATYPE_PREFIX, FEDERATED_INST_PREFIX, GPU_INST_PREFIX, INSTRUCTION_DELIM, LITERAL_PREFIX, OPERAND_DELIM, SP_INST_PREFIX, VALUETYPE_PREFIX`

### Method Summary

All Methods Instance Methods Concrete Methods
`org.apache.commons.lang3.tuple.Pair<String,​LineageItem>` `getLineageItem​(ExecutionContext ec)` Obtain lineage trace of an instruction with a single output.
`String` `getOutputVariableName()`

### Methods inherited from class org.apache.sysds.runtime.instructions.spark.SPInstruction

`getGraphString, getSPInstructionType, getType, postprocessInstruction, preprocessInstruction, processInstruction, requiresLabelUpdate`

### Methods inherited from class org.apache.sysds.runtime.instructions.Instruction

`getBeginColumn, getBeginLine, getEndColumn, getEndLine, getExtendedOpcode, getFilename, getInstID, getInstructionString, getLineNum, getOpcode, getOperator, getPrivacyConstraint, printMe, setInstID, setLocation, setLocation, setLocation, setLocation, setPrivacyConstraint, setPrivacyConstraint, toString, updateInstructionThreadID`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.sysds.runtime.lineage.LineageTraceable

`getLineageItems, hasSingleLineage`

### Field Detail

#### output

    public CPOperand output

#### input1

    public CPOperand input1

#### input2

    public CPOperand input2

#### input3

    public CPOperand input3

### Method Detail

#### getOutputVariableName

    public String getOutputVariableName()

#### getLineageItem

    public org.apache.commons.lang3.tuple.Pair<String,​LineageItem> getLineageItem​(ExecutionContext ec)

Description copied from interface: `LineageTraceable`
Obtain lineage trace of an instruction with a single output.

Specified by:
  `getLineageItem` in interface `LineageTraceable`
Parameters:
  `ec` - execution context w/ live variables
Returns:
  pair of (output variable name, output lineage item)